<?php
require( dirname(__FILE__) . '/../../../wp-load.php' );


//---------------exclui o modulo e todas as aulas relacionadas a ele

function excluirModulo($id_modulo, $id_curso, $id_usuario){

	//echo "<br>ID: ".$id_modulo." curso:".$id_curso." Usuario: ".$id_usuario."<br>";

	$args = array(
		'author' =>  $id_usuario,
		'post_type' => 'aula',
		'meta_query' => array(
			'relation' => 'AND',
			array(
				'key'     => 'ordem_aula',
				'value'   => 'null',
				'compare' => '!='
				),
			array(
				'key'     => 'id_curso',
				'compare' => '=',
				'value'   => $id_curso     
				),
			array(
				'key'     => 'id_modulo',
				'compare' => '=',
				'value'   => $id_modulo     
				)
			),
		'orderby' => 'meta_value_num', 
		'meta_key' => 'ordem_aula',
		'order' => 'ASC',
		'posts_per_page' => -1
		);

	$wp_query_btop_sel = new WP_Query($args);


	if ($wp_query_btop_sel->have_posts()) {//verifica se tem aulas para excluir

	   while ($wp_query_btop_sel->have_posts()) {//loop para excluir todas as aulas
	   	$wp_query_btop_sel->the_post(); 


	   	$argsAnexo = array(
	   		'taxonomy'   => 'anexos',
	   		'hide_empty' => false,
	   		'meta_query' => array(
	   			'relation' => 'AND',
	   			array(
	   				'key'       => 'aula_resp',
	   				'value'     => get_the_ID(),
	   				'compare'   => '='
	   				)
	   			)
	   		);

	   	$wp_Anexo = get_terms($argsAnexo);

	   	if(count($wp_Anexo) != 0)
	   	{
	   		foreach ($wp_Anexo as $dado) 
	   		{
	   			wp_delete_term( $dado->term_id, 'anexos' );
	   		}
	   	}

	   	wp_delete_post ( get_the_ID(), true );

	   }
	}
	        wp_delete_term( $id_modulo, 'modulos' );//exclui o modulo(termo)

	    }

//-------------exclui o curso e todos seus modulos e aulas
	    function excluirCurso($id_curso, $usuario){

	    	$infoModulo = get_term_meta( $id_curso, 'modulos', true );

	if($infoModulo == '1'){//-------------verifica se o curso possui modulos
		$argsCurso = array(
			'taxonomy'   => 'modulos',
			'hide_empty' => false,
			'meta_query' => array(
				array(
					'key'       => 'terms_taxo',
					'value'     => $id_curso,
					'compare'   => '='
					)
				)
			);

	    $dadosCurso = get_terms($argsCurso);//tras um array com todos os modulos do curso
	    
	    if(count($dadosCurso) != 0){

	    	foreach ($dadosCurso as $dado) {

	    		excluirModulo($dado->term_id, $id_curso, $usuario); 

	    	}

	    }

	}else{

		$argsAula = array(
			'author' =>  $usuario,
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'ordem_aula',
					'value'   => 'null',
					'compare' => '!='
					),
				array(
					'key'     => 'id_curso',
					'compare' => '=',
					'value'   => $id_curso     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'ordem_aula',
			'order' => 'ASC',
			'posts_per_page' => -1
			);

		$dadosAulaS = new WP_Query($argsAula);
		if ($dadosAulaS->have_posts()) {

			while ($dadosAulaS->have_posts()) {
				
				$dadosAulaS->the_post(); 
				wp_delete_post( get_the_ID(), true);

			}
		}
	}

	$id_foto = get_term_meta( $id_curso, 'foto_de_capa', true );
	wp_delete_attachment( $id_foto );

	wp_delete_term($id_curso, "curso");

}


//if(!function_exists('mime_content_type')) {

    function mime_content_type2($filename) {

        $mime_types = array(

            'txt' => 'text/plain',
            'htm' => 'text/html',
            'html' => 'text/html',
            'php' => 'text/html',
            'css' => 'text/css',
            'js' => 'application/javascript',
            'json' => 'application/json',
            'xml' => 'application/xml',
            'swf' => 'application/x-shockwave-flash',
            'flv' => 'video/x-flv',

            // images
            'png' => 'image/png',
            'jpe' => 'image/jpeg',
            'jpeg' => 'image/jpeg',
            'jpg' => 'image/jpeg',
            'gif' => 'image/gif',
            'bmp' => 'image/bmp',
            'ico' => 'image/vnd.microsoft.icon',
            'tiff' => 'image/tiff',
            'tif' => 'image/tiff',
            'svg' => 'image/svg+xml',
            'svgz' => 'image/svg+xml',

            // archives
            'zip' => 'application/zip',
            'rar' => 'application/x-rar-compressed',
            'exe' => 'application/x-msdownload',
            'msi' => 'application/x-msdownload',
            'cab' => 'application/vnd.ms-cab-compressed',

            // audio/video
            'mp3' => 'audio/mpeg',
            'qt' => 'video/quicktime',
            'mov' => 'video/quicktime',

            // adobe
            'pdf' => 'application/pdf',
            'psd' => 'image/vnd.adobe.photoshop',
            'ai' => 'application/postscript',
            'eps' => 'application/postscript',
            'ps' => 'application/postscript',

            // ms office
            'doc' => 'application/msword',
            'rtf' => 'application/rtf',
            'xls' => 'application/vnd.ms-excel',
            'ppt' => 'application/vnd.ms-powerpoint',

            // open office
            'odt' => 'application/vnd.oasis.opendocument.text',
            'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
        );

        $ext = strtolower(array_pop(explode('.',$filename)));

        if (array_key_exists($ext, $mime_types)) {

        	$reserved_words = array("charset=binary", ";", " ");
			$mimetypesd = str_replace($reserved_words, "", $mime_types[$ext]); 

            return $mimetypesd;
        }
        elseif (function_exists('finfo_open')) {
            $finfo = finfo_open(FILEINFO_MIME);
            $mimetype = finfo_file($finfo, $filename);
            finfo_close($finfo);

            $reserved_words = array("charset=binary", ";", " ");
			$mimetype = str_replace($reserved_words, "", $mimetype); 

            return $mimetype;
        }
        else {
            return 'application/octet-stream';
        }
    }
//}


function uploadImagem($arquivo){

	$id_Anx = null;//variavel que retornara o id do anexo
	$wordpress_upload_dir = wp_upload_dir();//caminho da pasta de download
	$i = 1; 

	$profilepicture = $_FILES[$arquivo];//pega o arquivo direto do formulario
	$nome = $profilepicture['name'];
	$ext = pathinfo($nome, PATHINFO_EXTENSION);
	$nome = geraSenha(10).'.'.$ext;
	
	preg_replace( '/[`^~\'"]/', null, iconv( 'UTF-8', 'ASCII//TRANSLIT', $nome ) );

	$new_file_path = $wordpress_upload_dir['path'] . '/' . $nome;
	$new_file_mime = null;

	//if(!function_exists('mime_content_type')) {
		$new_file_mime = mime_content_type2( $profilepicture['name'] );
	/*}else{
		$new_file_mime = mime_content_type( $profilepicture['tmp_name'] );
	}*/

	if( empty( $profilepicture ) )
		die( 'Nenhum arquivo selecionado.' );

	if( $profilepicture['error'] )
		die( $profilepicture['error'] );

	if( $profilepicture['size'] > wp_max_upload_size() )
		die( 'O tamanho da imagem é maior do que o permitido.' );

	if( !in_array( $new_file_mime, get_allowed_mime_types() ) )
		die( 'Wordpress não aceita esse tipo de arquivo' );

	while( file_exists( $new_file_path ) ) {
		$i++;
		//$new_file_path = $wordpress_upload_dir['path'] . '/' . $i . '_' . $profilepicture['name'];
		$new_file_path = $wordpress_upload_dir['path'] . '/' . $i . '_' . $nome;
	}

	if( move_uploaded_file( $profilepicture['tmp_name'], $new_file_path ) ) {

		$upload_id = wp_insert_attachment( array(
			'guid'           => $new_file_path, 
			'post_mime_type' => $new_file_mime,
			'post_title'     => preg_replace( '/\.[^.]+$/', '', $profilepicture['name'] ),
			'post_content'   => '',
			'post_status'    => 'inherit'
			), $new_file_path );

		require_once( ABSPATH . 'wp-admin/includes/image.php' );
		require_once( ABSPATH . 'wp-admin/includes/file.php' );
		require_once( ABSPATH . 'wp-admin/includes/media.php' );

		//wp_update_attachment_metadata( $upload_id, wp_generate_attachment_metadata( $upload_id, $new_file_path ) );

		//mostra no navegador o arquivo upado//wp_redirect( $wordpress_upload_dir['url'] . '/' . basename( $new_file_path ) );//$caminho = $wordpress_upload_dir['url'] . '/' . basename( $new_file_path );
		$id_Anx = $upload_id; 

	}

	return $id_Anx;

}

function uploadImagemPDF($arquivo){

	$id_Anx = null;//variavel que retornara o id do anexo
	$wordpress_upload_dir = wp_upload_dir();//caminho da pasta de download
	$i = 1; 
		
	$profilepicture = $_FILES[$arquivo];//pega o arquivo direto do formulario
	$pdf_name = $profilepicture['name'];
	$pdf_file = $profilepicture['name'];
	exec('gs -sDEVICE=pdfwrite -dCompatibilityLevel=1.4 -dNOPAUSE -dBATCH -dQUIET -sOutputFile=pdf_name.pdf'. $pdf_file.'');	
	$nome = 'pdf_name.pdf';
	$nome = preg_replace('/pdf_name.pdf/', $profilepicture['name'], $nome);
	$nome = preg_replace('/.pdf/', '', $nome);
	$nome = preg_replace('/\s+/', '_', $nome);
	$nome = removeAcentos($nome);
	$rand = rand(1000, 32768);
	$nome = $nome . '_' . $rand .'.pdf'; 

	
		
	preg_replace( '/[`^~\'"]/', null, iconv( 'UTF-8', 'ASCII//TRANSLIT', $nome ) );

	//$new_file_path = ABSPATH . "/wp-content/plugins/super-plataforma/UPAP" . '/' . $nome;
	$new_file_path = ABSPATH . "/wp-content/UPAP" . '/' . $nome;
	$new_file_mime = null;

	//if(!function_exists('mime_content_type')) {
		$new_file_mime = mime_content_type2( $profilepicture['name'] );
	/*}else{
		$new_file_mime = mime_content_type( $profilepicture['tmp_name'] );
	}*/

	if( empty( $profilepicture ) )
		die( 'Nenhum arquivo selecionado.' );

	if( $profilepicture['error'] )
		die( $profilepicture['error'] );

	if( $profilepicture['size'] > wp_max_upload_size() )
		die( 'O tamanho da imagem é maior do que o permitido.' );

	if( !in_array( $new_file_mime, get_allowed_mime_types() ) )
		die( 'Wordpress não aceita esse tipo de arquivo' );

	while( file_exists( $new_file_path ) ) {
		$i++;
		//$new_file_path = $wordpress_upload_dir['path'] . '/' . $i . '_' . $profilepicture['name'];
		$new_file_path = $wordpress_upload_dir['path'] . '/' . $i . '_' . $nome;
	}

	if( move_uploaded_file( $profilepicture['tmp_name'], $new_file_path ) ) {

		$upload_id = wp_insert_attachment( array(
			'guid'           => $new_file_path, 
			'post_mime_type' => $new_file_mime,
			'post_title'     => preg_replace( '/\.[^.]+$/', '', $profilepicture['name'] ),
			'post_content'   => '',
			'post_status'    => 'inherit'
			), $new_file_path );

		require_once( ABSPATH . 'wp-admin/includes/image.php' );
		require_once( ABSPATH . 'wp-admin/includes/file.php' );
		//require_once( ABSPATH . 'wp-admin/includes/media.php' );

		//wp_update_attachment_metadata( $upload_id, wp_generate_attachment_metadata( $upload_id, $new_file_path ) );

		//mostra no navegador o arquivo upado//wp_redirect( $wordpress_upload_dir['url'] . '/' . basename( $new_file_path ) );//$caminho = $wordpress_upload_dir['url'] . '/' . basename( $new_file_path );
		$id_Anx = $upload_id; 

	}

	return $nome;

}

function excluirAnexo($id_aula){

	$id_anexo = get_term_meta($id_aula, 'anexo_id', true);
	wp_delete_attachment( $id_anexo, true);
	wp_delete_term( $id_aula, 'anexos' );

}

function pegarCurso(){
	$args = array(
		'taxonomy'=> 'curso',
		'order' =>  'ASC',
		'hide_empty' =>  false,
		'meta_query' => array(
			array(
				'key'       => 'ordem_curso',
				'value'     => null,
				'compare'   => '!='
				)
			),
		'orderby' => 'meta_value_num', 
		'meta_key' => 'ordem_curso',
		'order' => 'ASC'
		);
    //$cats = get_terms(array('hide_empty'=>0,'taxonomy'=>array($tax)));
	$cats = get_terms( $args );
	return $cats;
}

function pegarModulos($id_curso)
{
	$args = array(
		'taxonomy'   => 'modulos',
		'parent'	 => 0,
		'hide_empty' => false,
		'meta_query' => array(
			'relation' => 'AND',
			array(
				'key'       => 'terms_taxo',
				'value'     => $id_curso,
				'compare'   => '='
				),

			array(
				'key'     => 'ordem_modulo',
				'value'   => 'null',
				'compare' => '!='
				)
			),
		'orderby' => 'meta_value_num', 
		'meta_key' => 'ordem_modulo',
		'order' => 'ASC',
		);

	$curso_modulos = get_terms($args);

	return $curso_modulos;
}


function pegarModulosFilho($id_curso,$id_modulo)
{
	$args = array(
		'taxonomy'   => 'modulos',
		'parent'	 => $id_modulo,
		'hide_empty' => false,
		'meta_query' => array(
			'relation' => 'AND',
			array(
				'key'       => 'terms_taxo',
				'value'     => $id_curso,
				'compare'   => '='
				),

			array(
				'key'     => 'ordem_modulo',
				'value'   => 'null',
				'compare' => '!='
				)
			),
		'orderby' => 'meta_value_num', 
		'meta_key' => 'ordem_modulo',
		'order' => 'ASC',
		);

	$curso_modulosfilho = get_terms($args);

	return $curso_modulosfilho;
}

function pegarAulas($curso, $modulo){
	$args=null;
	if($modulo==null){

		$args = array(
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'ordem_aula',
					'value'   => 'null',
					'compare' => '!='
					),
				array(
					'key'     => 'id_curso',
					'compare' => '=',
					'value'   => $curso     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'ordem_aula',
			'order' => 'ASC',
			'posts_per_page' => -1
			);
	}else{
		$args = array(
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'ordem_aula',
					'value'   => 'null',
					'compare' => '!='
					),
				array(
					'key'     => 'id_curso',
					'compare' => '=',
					'value'   => $curso     
					),
				array(
					'key'     => 'id_modulo',
					'compare' => '=',
					'value'   => $modulo     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'ordem_aula',
			'order' => 'ASC',
			'posts_per_page' => -1
			);
	}
	$aulas = new WP_Query($args);
	return $aulas;
}


function pegarAulasCurso($curso, $modulo){
	$args=null;
	if($modulo==null){

		$args = array(
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'ordem_aula',
					'value'   => 'null',
					'compare' => '!='
					),
				array(
					'key'     => 'id_curso',
					'compare' => '=',
					'value'   => $curso     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'ordem_aula',
			'order' => 'ASC',
			'posts_per_page' => -1
			);
	}else{
		$args = array(
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'ordem_aula',
					'value'   => 'null',
					'compare' => '!='
					),
				array(
					'key'     => 'id_curso',
					'compare' => '=',
					'value'   => $curso     
					),
				array(
					'key'     => 'id_modulo',
					'compare' => '=',
					'value'   => $modulo     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'ordem_aula',
			'order' => 'ASC',
			'posts_per_page' => -1
			);
	}
	$aulas = get_posts($args);
	return $aulas;
}

function contarAulas($id_modulo, $id_curso, $id_user)
{
	if($user_roles[0] == 'administrator'){
		$args2 = array(
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'id_modulo',
					'compare' => '=',
					'value'   => $id_modulo     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'id_modulo',
			'order' => 'ASC',
			'posts_per_page' => -1
			);
	}else{
		$args2 = array(
			'post_author' => $id_user,
			'post_type' => 'aula',
			'meta_query' => array(
				'relation' => 'AND',
				array(
					'key'     => 'id_modulo',
					'compare' => '=',
					'value'   => $id_modulo     
					)
				),
			'orderby' => 'meta_value_num', 
			'meta_key' => 'id_modulo',
			'order' => 'ASC',
			'posts_per_page' => -1
			);
	}

	$numero = 0;

	$aulas = new WP_Query($args2);
	while ($aulas->have_posts()) {
		$aulas->the_post();
		$numero++;
	} 

	return $numero;
}

function get_student_classes($id_curso, $id_aluno){
	$turmas = get_user_meta($id_aluno, 'turmas', true);
	$cursos = array();
	if($turmas != null){
		foreach ($turmas as $turma) {
			$cursos_turma = get_post_meta($turma, "cursos", true);
			//print_r($cursos_turma);
			if($cursos_turma != null){
				$diferente = array_diff($cursos_turma, $cursos);
				$cursos = array_merge($cursos, $diferente);
			}
		}

		if(in_array($id_curso, $cursos)){
			return 1;
		}else{
			return 0;
		}
	} else {
		return 0;
	}
}

function get_type_class($id_curso){

	$tipo = get_term_meta( $id_curso, 'tipo_de_curso_valor', true );
	return $tipo;
}

function pegar_turma($id_aluno, $id_curso){
	$turmas = get_user_meta($id_aluno, 'turmas', true);
	$id_turmas = array();
	if($turmas != null){
		foreach ($turmas as $turma) {
			$cursos_turma = get_post_meta($turma, "cursos", true);
			if(in_array($id_curso, $cursos_turma)){
				$id_turmas[] = $turma;
			}
		}

		return $id_turmas;

	}else{
		return null;
	}
}

function return_course($id_turma, $cursosAtuais){
	$cursos = get_post_meta($id_turma, 'cursos', true);
	$resultado = null;
	if($cursos != null && $cursosAtuais != null){
		$diferente = array_diff($cursosAtuais, $cursos);
		$resultado = array_merge($diferente, $cursosAtuais);
	}

	return $resultado;
}

function previous_class($id_aula, $id_modulo, $curso){

	$postlist_args = null;

	$ordem = get_post_meta($id_aula, 'ordem_aula', true);
	$ordem -= 1;

	if($id_aula != null){
		if($id_modulo == null){
			$postlist_args = array(
			    'post_type' => 'aula',
			    'meta_query' => array(
			        'relation' => 'AND',
			        array(
			            'key'     => 'ordem_aula',
			            'value'   => $ordem,
			            'compare' => '='
			        ),
			        array(
			            'key'     => 'id_curso',
			            'compare' => '=',
			            'value'   => $curso     
			        )
			    ),
			    'orderby' => 'meta_value_num', 
			    'meta_key' => 'ordem_aula',
			    'order' => 'ASC',
			    'posts_per_page' => -1
			);

		}else{

			$postlist_args = array(
		        'post_type' => 'aula',
		        'meta_query' => array(
		        	'relation' => 'AND',
			        array(
			            'key'     => 'ordem_aula',
			            'value'   => $ordem,
			            'compare' => '='
			        ),
			        array(
			            'key'     => 'id_modulo',
			            'compare' => '=',
			            'value'   => $id_modulo     
			        )
			    ),
			    'orderby' => 'meta_value_num', 
			    'meta_key' => 'ordem_aula',
			    'order' => 'ASC',
			    'posts_per_page' => -1
			);
		}

		$postlist = get_posts( $postlist_args );
	}

	return $postlist;
}

function common_classes($t_author, $t_student, $curso){
	$result = array_intersect($t_author, $t_student);
	$flag = false;
	if($result != null){
		foreach ($result as $turma) {
			$cursos_turma = get_post_meta($turma, "cursos", true);
			if(in_array($curso, $cursos_turma)){
				$flag = true;
				break;
			}
		}	
	}

	return $flag;
}


/*
// Function to change email address
 
function wpb_sender_email( $original_email_address ) {
    return $email_remetente;
}
 
// Function to change sender name
function wpb_sender_name( $original_email_from ) {
    return $nome_remetente ;
}
 
// Hooking up our functions to WordPress filters 
add_filter( 'wp_mail_from', 'wpb_sender_email' );
add_filter( 'wp_mail_from_name', 'wpb_sender_name' );
*/

//Função requisita ao inserir alunos novos por CSV e já marcar o curso ao qual eles fazem parte
function ingressar_aluno_turma ($aluno,$turma) {

			update_user_meta($aluno, 'turmas', $turma);


            $datas_total = array();
            foreach($turma as $id){
                $cursos = get_post_meta($id, 'cursos', true);
                $data_regturma = get_post_meta( $id, 'data_regturma', true );
                $inicio = get_post_meta( $id, 'data_inicio', true );
                $termino = get_post_meta( $id, 'data_termino', true );

				$diasfimturma = get_post_meta( $id, 'diasfimturma', true );//dias de acesso a turma
                                
                if ($diasfimturma > 0 AND $data_regturma == 1) {
                $termino = date('Y-m-d', strtotime('+'.$diasfimturma.' days'));
                }                
                                

                if ($data_regturma == 1) { $inicio = date("Y-m-d"); }

            
                foreach ($cursos as $curso) {
                    $datas = array(
                        $curso => array(
                            'inicio' => $inicio,
                            'termino' => $termino
                        )
                    ); 
                    if(array_key_exists($curso, $datas_total)){
                        if($datas_total[$curso]["termino"] != null){
                            if($termino != null){
                                if(strtotime($datas_total[$curso]["termino"]) < strtotime($termino) ){
                                    $datas_total[$curso]["termino"] = $termino;
                                }
                            }else{
                                $datas_total[$curso]["termino"] = $termino; 
                            }
                        }
                        if($datas_total[$curso]["inicio"] != null){
                            if($inicio != null){
                                if(strtotime($datas_total[$curso]["inicio"]) < strtotime($inicio)){
                                    $datas_total[$curso]["inicio"] = $inicio;
                                }
                            }else{
                                $datas_total[$curso]["inicio"] = $inicio;
                            }
                        }
                    }else{
                        $datas_total = $datas + $datas_total;
                    }
                }
            }
                add_user_meta($aluno, 'cursos', $datas_total);


}

//Verifica se a aula foi marcada como assistida
function  VerAulaAssistida ($aula, $user_login) {
	global $wpdb;
	$table_confirma_aula = $wpdb->prefix . 'EAD_confirmar_aula';

	 $resultado_as = $wpdb->get_results( 'SELECT user_login FROM '.$table_confirma_aula.' WHERE id_aula = "'.$aula.'" AND user_login = "'.$user_login.'" ' );

	 if($resultado_as == null) { $return_as = 1; } else { $return_as = 2; }
	 return $return_as;
                                                
}

// Generate token login aluno
function getTokenLogin($length){
 $token = "";
 $codeAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
 $codeAlphabet.= "abcdefghijklmnopqrstuvwxyz";
 $codeAlphabet.= "0123456789";
 $max = strlen($codeAlphabet); // edited

 for ($i=0; $i < $length; $i++) {
  $token .= $codeAlphabet[random_int(0, $max-1)];
 }

 return $token;
}


//Função que pega thumb do Youtube
function extractVideoID($url){
    $regExp = "/^.*((youtu.be\/)|(v\/)|(\/u\/\w\/)|(embed\/)|(watch\?))\??v?=?([^#\&\?]*).*/";
    preg_match($regExp, $url, $video);
    return $video[7];
}
 
function getYouTubeThumbnailImage($video_id) {
    return "http://i3.ytimg.com/vi/$video_id/maxresdefault.jpg"; //pass 0,1,2,3 for different sizes like 0.jpg, 1.jpg
}
 
//Função que pega thumb do Vimeo
function getVimeoId($url)
{
    if (preg_match('#(?:https?://)?(?:www.)?(?:player.)?vimeo.com/(?:[a-z]*/)*([0-9]{6,11})[?]?.*#', $url, $m)) {
        return $m[1];
    }
    return false;
}
 
function getVimeoThumb($id)
{
    $arr_vimeo = unserialize(file_get_contents("http://vimeo.com/api/v2/video/$id.php"));
    //return $arr_vimeo[0]['thumbnail_small']; // returns small thumbnail
    // return $arr_vimeo[0]['thumbnail_medium']; // returns medium thumbnail
    return $arr_vimeo[0]['thumbnail_large']; // returns large thumbnail
}



//Gera Senhas
function geraSenha($tamanho = 8, $maiusculas = true, $numeros = true, $simbolos = false)
{
$lmin = 'abcdefghijklmnopqrstuvwxyz';
$lmai = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
$num = '1234567890';
$simb = '!@#$%*-';
$retorno = '';
$caracteres = '';

$caracteres .= $lmin;
if ($maiusculas) $caracteres .= $lmai;
if ($numeros) $caracteres .= $num;
if ($simbolos) $caracteres .= $simb;

$len = strlen($caracteres);
for ($n = 1; $n <= $tamanho; $n++) {
$rand = mt_rand(1, $len);
$retorno .= $caracteres[$rand-1];
}
return $retorno;
}

//Exemplos de uso abaixo:
// Gera uma senha com 10 carecteres: letras (min e mai), números
//$senha = geraSenha(10);
// gfUgF3e5m7

// Gera uma senha com 9 carecteres: letras (min e mai)
//$senha = geraSenha(9, true, false);
// BJnCYupsN

// Gera uma senha com 6 carecteres: letras minúsculas e números
//$senha = geraSenha(6, false, true);
// sowz0g

// Gera uma senha com 15 carecteres de números, letras e símbolos
//$senha = geraSenha(15, true, true, true);
// fnwX@dGO7P0!iWM

//-----------------------------------------------------


//Registrando Logs do Aluno

function RegistraLogAluno($id_aluno,$id_curso,$id_aula,$atividade)
{
	global $wpdb;
    $table_logs_aluno = $wpdb->prefix . 'LOGS_aluno';

    $wpdb->insert( $table_logs_aluno, 
      array(
        'id_aluno'    	=> $id_aluno, 
        'id_curso'      => $id_curso,
        'id_aula'    	=> $id_aula,         
        'atividade'    	=> $atividade
      ),
      array( '%d', '%d', '%d', '%s','%s'  ) 
    );
}

function RegistraObsAluno($id_aluno,$observacao,$alunover)
{
	global $wpdb;
    $table_obs_aluno = $wpdb->prefix . 'OBS_aluno';

    $wpdb->insert( $table_obs_aluno, 
      array(
        'id_aluno'    	=> $id_aluno, 
        'observacao'    => $observacao,
        'alunover'    	=> $alunover
      ),
      array( '%d', '%s' , '%d' ) 
    );
}



//Converte Número em Extenso
class Extenso
{
    public static function removerFormatacaoNumero( $strNumero )
    {

        $strNumero = trim( str_replace( "R$", null, $strNumero ) );

        $vetVirgula = explode( ",", $strNumero );
        if ( count( $vetVirgula ) == 1 )
        {
            $acentos = array(".");
            $resultado = str_replace( $acentos, "", $strNumero );
            return $resultado;
        }
        else if ( count( $vetVirgula ) != 2 )
        {
            return $strNumero;
        }

        $strNumero = $vetVirgula[0];
        $strDecimal = mb_substr( $vetVirgula[1], 0, 2 );

        $acentos = array(".");
        $resultado = str_replace( $acentos, "", $strNumero );
        $resultado = $resultado . "." . $strDecimal;

        return $resultado;

    }

    public static function converte( $valor = 0, $bolExibirMoeda = true, $bolPalavraFeminina = false )
    {

        $valor = self::removerFormatacaoNumero( $valor );

        $singular = null;
        $plural = null;


        $c = array("", "cem", "duzentos", "trezentos", "quatrocentos","quinhentos", "seiscentos", "setecentos", "oitocentos", "novecentos");
        $d = array("", "dez", "vinte", "trinta", "quarenta", "cinquenta","sessenta", "setenta", "oitenta", "noventa");
        $d10 = array("dez", "onze", "doze", "treze", "quatorze", "quinze","dezesseis", "dezesete", "dezoito", "dezenove");
        $u = array("", "um", "dois", "três", "quatro", "cinco", "seis","sete", "oito", "nove");

        if ( $bolPalavraFeminina )
        {
            if ($valor == 1)
                $u = array("", "uma", "duas", "três", "quatro", "cinco", "seis","sete", "oito", "nove");
            else
                $u = array("", "um", "duas", "três", "quatro", "cinco", "seis","sete", "oito", "nove");

            $c = array("", "cem", "duzentas", "trezentas", "quatrocentas","quinhentas", "seiscentas", "setecentas", "oitocentas", "novecentas");
        }

        $z = 0;

        $valor = number_format( $valor, 2, ".", "." );
        $inteiro = explode( ".", $valor );

        for ( $i = 0; $i < count( $inteiro ); $i++ )
            for ( $ii = mb_strlen( $inteiro[$i] ); $ii < 3; $ii++ )
                $inteiro[$i] = "0" . $inteiro[$i];

        // $fim identifica onde que deve se dar junção de centenas por "e" ou por "," ;)
        $rt = null;
        $fim = count( $inteiro ) - ($inteiro[count( $inteiro ) - 1] > 0 ? 1 : 2);
        for ( $i = 0; $i < count( $inteiro ); $i++ )
        {
            $valor = $inteiro[$i];
            $rc = (($valor > 100) && ($valor < 200)) ? "cento" : $c[$valor[0]];
            $rd = ($valor[1] < 2) ? "" : $d[$valor[1]];
            $ru = ($valor > 0) ? (($valor[1] == 1) ? $d10[$valor[2]] : $u[$valor[2]]) : "";

            $r = $rc . (($rc && ($rd || $ru)) ? " e " : "") . $rd . (($rd && $ru) ? " e " : "") . $ru;
            $t = count( $inteiro ) - 1 - $i;
            $r .= $r ? " " . ($valor > 1 ? $plural[$t] : $singular[$t]) : "";
            if ( $valor == "000")
                $z++;
            elseif ( $z > 0 )
                $z--;

            if ( ($t == 1) && ($z > 0) && ($inteiro[0] > 0) )
                $r .= ( ($z > 1) ? " de " : "") . $plural[$t];

            if ( $r )
                $rt = $rt . ((($i > 0) && ($i <= $fim) && ($inteiro[0] > 0) && ($z < 1)) ? ( ($i < $fim) ? ", " : " e ") : " ") . $r;
        }

        $rt = mb_substr( $rt, 1 );

        return($rt ? trim( $rt ) : "zero");

    }
}
//echo Extenso::converte('12,50', true, false);
function removeAcentos($string, $array_to_remove = null) {
    $string = preg_replace ( array('/Á/','/À/','/Â/','/Ã/','/Ä/'), 'A', $string );
    $string = preg_replace ( array('/á/','/à/','/â/','/ã/','/ä/','/ª/'), 'a', $string );
    $string = preg_replace ( array('/É/','/È/','/Ê/','/Ë/'), 'E', $string );
    $string = preg_replace ( array('/é/','/è/','/ê/','/ë/'), 'e', $string );
    $string = preg_replace ( array('/Í/','/Ì/','/Î/','/Ï/'), 'I', $string );
    $string = preg_replace ( array('/í/','/ì/','/î/','/ï/'), 'i', $string );
    $string = preg_replace ( array('/Ó/','/Ò/','/Ô/','/Õ/','/Ö/'), 'O', $string );
    $string = preg_replace ( array('/ó/','/ò/','/ô/','/õ/','/ö/','/º/'), 'o', $string );
    $string = preg_replace ( array('/Ú/','/Ù/','/Û/','/Ü/'), 'U', $string );
    $string = preg_replace ( array('/ú/','/ù/','/û/','/ü/'), 'u', $string );
    $string = str_replace ( '/Ç/', 'C', $string );
    $string = str_replace ( '/ç/', 'c', $string );
    if (is_array ( $array_to_remove )) {
        $string = str_replace ( $array_to_remove, '', $string );
    }
	return $string;


}

//COPIANDO PASTAS E ARQUIVOS
/*
function copiar_upap($diretorio, $destino, $ver_acao = false){
      if ($destino{strlen($destino) - 1} == '/'){
         $destino = substr($destino, 0, -1);
        }
      if (!is_dir($destino)){
         if ($ver_acao){
            echo "Criando diretorio {$destino}\n";
            }
         mkdir($destino, 0755, true);
      }

      $folder = opendir($diretorio);

      while ($item = readdir($folder)){
         if ($item == '.' || $item == '..'){
            continue;
            }
         if (is_dir("{$diretorio}/{$item}")){
            copy_dir("{$diretorio}/{$item}", "{$destino}/{$item}", $ver_acao);
         }else{
            if ($ver_acao){
               echo "Copiando {$item} para {$destino}"."\n";
            }
            copy("{$diretorio}/{$item}", "{$destino}/{$item}");
            }
      }
   }
*/